@echo off
REM ============================================================================
REM Batch file originally programmed by Mark D. Rejhon <marky@ottawa.com>
REM Public domain, freely modifiable and distributable.  Just leave my
REM name in here for credit, that's all! :)  You may add your blurb here.
REM ============================================================================

cls
if exist GLQUAKE.EXE goto :GLQEXISTS
echo.
echo ERROR:
echo This batch file needs to be run in the same directory as GLQUAKE.EXE
echo Please make sure that this batch file is in your \QUAKE directory.
echo.
pause
goto :END
:GLQEXISTS

REM If user is running 120Hz refresh, change to 60Hz for purpose of GLQuake.
if !%SST_SCREENREFRESH%!==!120! echo.
if !%SST_SCREENREFRESH%!==!120! echo The refresh rate is 120Hz which slows down the DAC on the 3Dfx card.
if !%SST_SCREENREFRESH%!==!120! echo Setting to 60Hz for better GLQuake performance.
if !%SST_SCREENREFRESH%!==!120! set SST_SCREENREFRESH=60

REM Display menu
echo.
echo 
echo GLQuake 3Dfx Performance Menu by Mark D. Rejhon (ag115@freenet.carleton.ca)
echo Framerates in rightmost column is 'TIMEDEMO DEMO2' test on my P166 system.
echo 
echo.
echo 1) 512x384 Max framerate, without tearing - Fastest and Smoothest      - 43fps
echo 2) 512x384 Limit framerate to max 36fps   - More consistent framerate  - 35fps
echo 3) 512x384 Full blast maximum framerate   - With tearing, may be jumpy - 50fps
echo 4) 640x480 Max framerate, without tearing - Fast and Smooth            - 32fps
echo 5) 640x480 Limit framerate to max 30fps   - More consistent framerate  - 29fps
echo 6) 640x480 Full blast maximum framerate   - With tearing, may be jumpy - 41fps
echo.
echo 
choice /N /C:12345678 Please enter the number of your choice above:
cls
echo.
if errorlevel 6 goto R640FULL:
if errorlevel 5 goto R640MAX30:
if errorlevel 4 goto R640MAX60:
if errorlevel 3 goto R512FULL:
if errorlevel 2 goto R512MAX36:
if errorlevel 1 goto R512MAX72:

:R512MAX72
echo Now running 512x384 max framerate, without tearing.
set SST_SWAP_EN_WAIT_ON_VSYNC=1
set FX_GLIDE_SWAPINTERVAL=1
set GLQUAKE_OPTIONS=-width 512 -height 384
goto :RUNGLQ

:R512MAX36
echo Now running 512x384 limit framerate to max 36fps.
set SST_SWAP_EN_WAIT_ON_VSYNC=1
set FX_GLIDE_SWAPINTERVAL=2
set GLQUAKE_OPTIONS=-width 512 -height 384
goto :RUNGLQ

:R512FULL
echo Now running 512x384 full blast maximum framerate, with tearing.
set SST_SWAP_EN_WAIT_ON_VSYNC=0
set FX_GLIDE_SWAPINTERVAL=0
set GLQUAKE_OPTIONS=-width 512 -height 384
goto :RUNGLQ

:R640MAX60
echo Now running 640x480 max framerate, without tearing.
set SST_SWAP_EN_WAIT_ON_VSYNC=1
set FX_GLIDE_SWAPINTERVAL=1
set GLQUAKE_OPTIONS=-width 640 -height 480
goto :RUNGLQ

:R640MAX30
echo Now running 640x480 limit framerate to max 30fps.
set SST_SWAP_EN_WAIT_ON_VSYNC=1
set FX_GLIDE_SWAPINTERVAL=2
set GLQUAKE_OPTIONS=-width 640 -height 480
goto :RUNGLQ

:R640FULL
echo Now running 640x480 full blast maximum framerate, with tearing.
set SST_SWAP_EN_WAIT_ON_VSYNC=0
set FX_GLIDE_SWAPINTERVAL=0
set GLQUAKE_OPTIONS=-width 640 -height 480
goto :RUNGLQ

:RUNGLQ
REM Make sure we did not run out of environment variables memory.
cls
if !%SST_SWAP_EN_WAIT_ON_VSYNC%!==!! goto :ENVERROR
if !%FX_GLIDE_SWAPINTERVAL%!==!! goto :ENVERROR
if !%GLQUAKE_OPTIONS%!==!! goto :ENVERROR
glquake %GLQUAKE_OPTIONS% +_windowed_mouse 1 -window -nocdaudio %1 %2 %3 %4 %5 %6 %7 %8 %9
goto :END

:ENVERROR
echo.
echo ERROR: Out of environment space.
echo WHY:   Required for performance enhancing environment variables.
echo.
echo You can fix this problem with these instructions:
echo 1. Hit Alt-Space or right click on the upper-left corner icon for this window.
echo 2. Select "Properties" on the menu that appears.
echo 3. Select the "Memory" tab on the window that appears.
echo 4. Set the "Initial Environment" textbox to the value "2048".
echo 5. Click on "OK"
echo 6. Close this DOS window and then try again
echo.
pause
goto :END

:END

